/*****************************************************************************
 * lirc.c: interface to the lirc driver
 *****************************************************************************
 * $Id: lirc.c,v 1.2 2003/01/14 08:00:42 keuleu Exp $
 *****************************************************************************
 * Copyright (C) 2001 Keuleu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************
 *
 * This software was based on xawtv. Those portions are
 * Copyright (C) 2000 Gerd Knorr <kraxel@cs.tu-berlin.de>
 *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>

#include "config.h"
#include "commands.h"

#ifdef HAVE_LIBLIRC_CLIENT
# include <lirc/lirc_client.h>
#endif
#include "lirc.h"

/*-----------------------------------------------------------------------*/

extern int debug;

#ifdef HAVE_LIBLIRC_CLIENT
static struct lirc_config *config;
#endif

int lirc_tv_init()
{
#ifdef HAVE_LIBLIRC_CLIENT
    int fd;
    
    if (-1 == (fd = lirc_init("xawdecode",debug))) {
      if (debug)
	    fprintf(stderr,"no infrared remote support available\n");
	return -1;
    }
    
    if (0 != lirc_readconfig(NULL,&config,NULL)) {
	lirc_deinit();
	return -1;
    }
    fcntl(fd,F_SETFL,O_NONBLOCK);
    fcntl(fd,F_SETFD,FD_CLOEXEC);
    
    return fd;
#else
    return -1;
#endif
}

int lirc_tv_havedata()
{
#ifdef HAVE_LIBLIRC_CLIENT
    char *code,*cmd;
    int ret=-1;
    
    while (lirc_nextcode(&code)==0 && code!=NULL)
      {
        ret = 0;
        while (lirc_code2char(config,code,&cmd)==0 && cmd!=NULL)
          {
            if (debug)
              fprintf(stderr,"lirc: \"%s\"\n", cmd);
            do_command(cmd);
          }
        free(code);
      }
    return ret;
#else
    return 0;
#endif
}
